diff --git a/rathaxes/samples/e1000/e1000.rti b/rathaxes/samples/e1000/e1000.rti
--- a/rathaxes/samples/e1000/e1000.rti
+++ b/rathaxes/samples/e1000/e1000.rti
@@ -1,157 +1,125 @@
-interface e1000 : Socket, Ethernet, DMA, PCI, LKM, Builtin
+interface e1000 : Socket, Ethernet, Device, DMA, PCI, LKM, Builtin
 {
-    required variable   Builtin::number rx_ring_size;
-    required variable   Builtin::number tx_ring_size;
-    required variable   Builtin::number rx_buffer_len;
-    required variable   Builtin::number tx_max_data_per_desc;
+    required variable Builtin::number rx_ring_size;
+    required variable Builtin::number tx_ring_size;
+    required variable Builtin::number rx_buffer_len;
+    required variable Builtin::number tx_max_data_per_desc;
 
-    provided type   RxDescriptor
+    // Hardware values/data structures, should probably be in the front-end:
+    provided type   Register            { decl data_types(); }
+    provided type   Command             { decl data_types(); }
+    provided type   TxDescriptorFlag    { decl data_types(); }
+    provided type   RxDescriptor        { decl data_types(); }
+    provided type   TxDescriptor        { decl data_types(); }
+
+    provided type   Buffer
     {
-        chunk       LKM::includes();
         decl        data_types();
-        method      init();
+
+        method      init(Socket::SKBuff, DMA::DMAHandle);
+
+        attribute   Socket::SKBuff.scalar   sk_buff;
+        attribute   DMA::DMAHandle.scalar   dma;
     }
 
-    provided type   TxDescriptor
+    provided type   Context
     {
         decl        data_types();
-        method      init();
+
+        chunk       LKM::includes();
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+        chunk       Ethernet::HardwareContext();
+
+        // NOTE: Those callbacks/hooks should probably be in the front-end:
+
+        chunk       Ethernet::adapter_init_context(Ethernet::Device, Builtin::symbol);
+        chunk       Ethernet::adapter_reset(Ethernet::Device);
+        chunk       Ethernet::adapter_load_mac_address(Ethernet::Device);
+        chunk       Ethernet::adapter_setup_rx_tx(Ethernet::Device);
+        chunk       Ethernet::adapter_enable_interrupts(Ethernet::Device);
+        chunk       Ethernet::adapter_disable_interrupts(Ethernet::Device);
+        chunk       Ethernet::adapter_handle_interrupt(Ethernet::Device);
+        chunk       Ethernet::adapter_xmit(Ethernet::Device, Socket::SKBuff);
+        chunk       Ethernet::adapter_disable_rx(Ethernet::Device);
+        chunk       Ethernet::adapter_disable_tx(Ethernet::Device);
+        chunk       Ethernet::adapter_free_rx_tx(Ethernet::Device);
+
+        method      init(Ethernet::Device net_dev, Builtin::symbol);
+        method      print_status();
+        method      reg_read32(Register);
+        method      reg_write32(Register, Builtin::number);
+        method      reg_set32(Register, Builtin::number);
+        method      reg_unset32(Register, Builtin::number);
+
+        // XXX: Circular dependency with the rings, this will prevent us to
+        // call methods even when issue $46 is resolved, it also forces us to
+        // hardcode generated types in the definition of the type, and they
+        // can't be "dereferenced" (e.g: local.hw_ctx.rx_ring.desc_size can't
+        // work since local.hw_ctx.rx_ring is just going to be a symbol).
+        attribute   Builtin::symbol.scalar  rx_ring;
+        attribute   Builtin::symbol.scalar  tx_ring;
+        attribute   Builtin::symbol.ref     io_addr;
+        attribute   Ethernet::Device.ref    net_dev;
+    }
+
+    provided type   Ring
+    {
+        decl        data_types();
+
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+
+        method      init(e1000::Context, Builtin::number, Builtin::number);
+
+        // Keep a backref to The context since it's going to be needed for of
+        // operations involving the ethernet device, flags on the context, etc.
+        attribute   Context.ref             hw_ctx;
+        attribute   DMA::DMAHandle.scalar   dma;
+        attribute   Builtin::number.scalar  size;   // Total size in bytes
+        attribute   Builtin::symbol.ref     descs;
+        attribute   Buffer.ref              buffs;
     }
 
     provided type   RxRing
     {
         decl        data_types();
-        method      init();
 
-        /* XXX: Callback that should be in the front-end: */
-        chunk       Ethernet::adapter_init_rx(Ethernet::Device);
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
 
-        attribute   DMA::DMAHandle.scalar   dma_base;
+        method      init(e1000::Context, Builtin::number);
+        method      alloc(); // Returns != 0 on failure
+        method      free();
+        method      configure();
+
+        // Re-expose all the Ring attributes + the size of a single descriptor:
+        attribute   Context.ref             hw_ctx;
+        attribute   DMA::DMAHandle.scalar   dma;
         attribute   Builtin::number.scalar  size;
-    }
-
-    provided type   Context
-    {
-        chunk       Ethernet::HardwareContext();
-        decl        data_types();
-
-        /* XXX:
-         * These callbacks/Hooks which should probably be in the front-end.
-         * Also, I'm not too happy about the names, it's difficult to make
-         * the difference between the probe and open parts.
-         */
-        chunk       Ethernet::adapter_init_context(Ethernet::Device,
-                                                   Builtin::number,
-                                                   Builtin::symbol);
-        chunk       Ethernet::adapter_reset(Ethernet::Device);
-        chunk       Ethernet::adapter_load_mac_address(Ethernet::Device);
-        chunk       Ethernet::adapter_setup(Ethernet::Device);
-
-        attribute   RxRing.scalar   rx_ring;
-        /* XXX: circular dependency with Contex: */
-        //attribute   TxRing.scalar   tx_ring;
+        attribute   RxDescriptor.ref        descs;
+        attribute   Builtin::number.scalar  desc_size;
+        attribute   Buffer.ref              buffs;
     }
 
     provided type   TxRing
     {
+        decl        data_types();
+
         chunk       LKM::prototypes();
         chunk       LKM::code();
-        decl        data_types();
-        method      init();
 
-        /* XXX: Callback that should be in the front-end: */
-        chunk       Ethernet::adapter_init_tx(Ethernet::Device);
+        method      init(e1000::Context, Builtin::number);
+        method      alloc(); // Returns != 0 on failure
+        method      free();
+        method      configure();
 
-        /* Clean the ring (i.e: move the head closer to the tail): */
-        method      clean();
-        /* Return the number of clean descriptors left in the ring: */
-        method      descriptors_remaining();
-        method      tso_cksum_offload(Socket::SKBuff);
-        method      put(Socket::SKBuff);
-        /* Signal the device that new dirty descriptors are on the ring: */
-        method      start_xmit(e1000::Context);
-    }
-
-    /*
-     * These two types should actually be registers definitions in the frontend:
-     */
-    provided type   Register
-    {
-        decl        data_types();
-        method      init(Builtin::number);
-    }
-
-    provided type   Commands
-    {
-        decl        data_types();
-    }
-
-    provided type   TxDescriptorFlags
-    {
-        decl        data_types();
-    }
-
-    /*
-     * This should take an e1000::Context as the first argument but this was
-     * not working as wished.
-     */
-    provided sequence   print_status(Ethernet::Device)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   activate_device_interruption(Ethernet::Device)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   set_up_device(Ethernet::Device)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   free_rx_tx(Ethernet::Device dev)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   handle_interrupt(Ethernet::Device)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   xmit(Ethernet::Device, Socket::AbstractSKBuff)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_read32(e1000::Context, e1000::Register)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_write32(e1000::Context, e1000::Register, ::number)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_set32(e1000::Context, e1000::Register, ::number)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_unset32(e1000::Context, e1000::Register, ::number)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
+        // Re-expose all the Ring attributes + the size of a single descriptor:
+        attribute   Context.ref             hw_ctx;
+        attribute   DMA::DMAHandle.scalar   dma;
+        attribute   Builtin::number.scalar  size;
+        attribute   TxDescriptor.ref        descs;
+        attribute   Builtin::number.scalar  desc_size;
+        attribute   Buffer.ref              buffs;
     }
 }
diff --git a/rathaxes/samples/e1000/ethernet.blt b/rathaxes/samples/e1000/ethernet.blt
--- a/rathaxes/samples/e1000/ethernet.blt
+++ b/rathaxes/samples/e1000/ethernet.blt
@@ -1,4 +1,4 @@
-with Ethernet, PCI, LKM, Log, Builtin
+with Ethernet, Socket, PCI, LKM, Log, Builtin
 {
     template type   Ethernet::ProtocolId()
     {
@@ -9,7 +9,7 @@
 
         chunk LKM::prototypes()
         {
-            static const char   *rtx_ethernet_protocol_id_to_str(unsigned short);
+            static const char *rtx_ethernet_protocol_id_to_str(unsigned short);
         }
 
         chunk LKM::data()
@@ -28,7 +28,7 @@
 
         chunk LKM::code()
         {
-            static const char   *rtx_ethernet_protocol_id_to_str(unsigned short proto_id)
+            static const char *rtx_ethernet_protocol_id_to_str(unsigned short proto_id)
             {
                 for (int i = 0;
                      i != sizeof(rtx_ethernet_proto_table) / sizeof(rtx_ethernet_proto_table[0]);
@@ -61,7 +61,7 @@
 
         method  init(Builtin::symbol dev)
         {
-            ${self} = (${Ethernet::AbstractDevice} *)${dev};
+            ${self} = (${Ethernet::AbstractDevice.ref})${dev};
         }
 
         map
@@ -104,9 +104,12 @@
         {
             static int rtx_ethernet_alloc_rx_skbuff(${Ethernet::Device.ref} self, ${Socket::SKBuff.ref} sk_buff, ${Builtin::number} size)
             {
-                ${Socket::AbstractSKBuff} k_sk_buff = netdev_alloc_skb(${local.self.net_device.k_net_dev}, ${local.size});
-                if (${local.k_sk_buff) {
-                    ${local.sk_buff.init(local.k_sk_buff, local.size)};
+                ${Socket::AbstractSKBuff.ref} k_skb = netdev_alloc_skb(${local.self.net_device.k_net_dev}, ${local.size});
+                if (${local.k_skb}) {
+                    // XXX meh, can't use the init method since we get a copy
+                    // of the pointer, so we have to do this which is
+                    // inconsistent with the rest of code:
+                    sk_buff->skbuff = k_skb;
                     return 0;
                 }
                 return 1;
@@ -148,7 +151,7 @@
         }
     }
 
-    template sequence   Ethernet::open(Ethernet::Device dev)
+    template sequence   Ethernet::open()
     {
         chunk   LKM::includes()
         {
@@ -157,100 +160,115 @@
 
         chunk LKM::prototypes()
         {
-            static int  rtx_ethernet_open(struct net_device *);
+            static int rtx_ethernet_open(struct net_device *);
         }
 
         chunk LKM::code()
         {
-            static int  rtx_ethernet_open(struct net_device *dev)
+            static int rtx_ethernet_open(struct net_device *dev)
             {
-                /*
-                 * XXX The casts are here because the compiler doesn't resolve
-                 * "enclosed" type (e.g: local.var.enclosed) correctly.
-                 */
                 ${Ethernet::AbstractDevice.ref} rtx_net_dev;
-                { /* XXX: I end up with a placeholder if I don't open a scope */
-                    ${local.rtx_net_dev.init(local.dev)};
-                }
+                ${local.rtx_net_dev.init(local.dev)};
                 ${Ethernet::Device.ref} rtx_ether_ctx = ${local.rtx_net_dev.rtx_ether_ctx};
 
-                int error;
-                {
-                    ${Log::info("installing the interrupt handler")};
-                }
-                error = request_irq(${local.rtx_ether_ctx.irq},
-                                    rtx_ethernet_interrupt_handler,
-                                    IRQF_SHARED,
-                                    ${config.name},
-                                    dev);
-                if (error)
-                {
+                ${pointcut Ethernet::adapter_setup_rx_tx(local.rtx_ether_ctx)};
+
+                ${Log::info("Installing the interrupt handler")};
+                int error = request_irq(
+                    ${local.rtx_ether_ctx.irq},
+                    rtx_ethernet_interrupt_handler,
+                    IRQF_SHARED,
+                    ${config.name},
+                    dev
+                );
+                if (error) {
                     ${Log::info("Cannot register the interrupt handler")};
                     return error;
                 }
-                ${pointcut Ethernet::adapter_setup(local.rtx_ether_ctx)};
-                ${pointcut Ethernet::adapter_init_rx(local.rtx_ether_ctx)};
-                ${pointcut Ethernet::adapter_init_tx(local.rtx_ether_ctx)};
-                ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx)};
+
+                ${pointcut Ethernet::adapter_enable_interrupts(local.rtx_ether_ctx)};
+
+                return 0;
+
+            rtx_ethernet_open_fail:
+                return -EIO; // XXX Probably not appropriate.
+            }
+        }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
+    }
+
+    template sequence   Ethernet::send()
+    {
+        chunk LKM::prototypes()
+        {
+            static int rtx_ethernet_xmit(struct sk_buff *skb, struct net_device *dev);
+        }
+
+        chunk LKM::code()
+        {
+            static int rtx_ethernet_xmit(struct sk_buff *k_skb, struct net_device *net_dev)
+            {
+                ${Ethernet::Device.ref} rtx_ether_ctx = netdev_priv(net_dev);
+                ${Socket::SKBuff.ref} rtx_skb;
+
+                ${cast local.k_skb as Socket::AbstractSKBuff.ref};
+                ${local.rtx_skb.init(local.k_skb)};
+
+                ${Log::info("we have one packet to transmit!")};
+                ${pointcut Ethernet::adapter_xmit(local.rtx_ether_ctx, local.rtx_skb)};
+            }
+        }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
+    }
+
+    template sequence   Ethernet::close()
+    {
+        chunk LKM::prototypes()
+        {
+            static int rtx_ethernet_close(struct net_device *);
+        }
+
+        chunk LKM::code()
+        {
+            static int rtx_ethernet_close(struct net_device *net_dev)
+            {
+                ${cast local.net_dev as Ethernet::AbstractDevice.ref};
+                ${Ethernet::Device.ref} rtx_ether_ctx = ${local.net_dev.rtx_ether_ctx};
+
+                ${pointcut Ethernet::adapter_disable_rx(local.rtx_ether_ctx)};
+
+                netif_tx_disable(net_dev);
+                ${pointcut Ethernet::adapter_disable_tx(local.rtx_ether_ctx)};
+
+                ${pointcut Ethernet::adapter_disable_interrupts(local.rtx_ether_ctx)};
+                free_irq(${local.rtx_ether_ctx.irq}, dev);
+                ${Log::info("interrupt handler free'ed")};
+
+                // TODO/XXX: There is definitely more stuff to do around here
+                // (e.g: clean the rings, flush some stuff...)
+
+                ${pointcut Ethernet::adapter_reset(local.rtx_ether_ctx)};
+                ${pointcut Ethernet::adapter_free_rx_tx(local.rtx_ether_ctx)};
 
                 return 0;
             }
         }
-    }
 
-    template sequence   Ethernet::send(Ethernet::Device dev, Socket::AbstractSKBuff skb)
-    {
-        chunk LKM::prototypes()
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
         {
-            static int  rtx_ethernet_xmit(struct sk_buff* skb, struct net_device *dev);
-        }
-
-        chunk LKM::code()
-        {
-            static int  rtx_ethernet_xmit(struct sk_buff* kernel_skb, struct net_device *net_dev)
-            {
-                ${Ethernet::Device.ref} rtx_ether_ctx = netdev_priv(net_dev);
-                ${Socket::AbstractSKBuff.ref} rtx_skb = (${Socket::AbstractSKBuff.ref}) kernel_skb;
-
-                ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx, local.rtx_skb)};
-            }
         }
     }
 
-    template sequence   Ethernet::close(Ethernet::Device dev)
-    {
-        chunk LKM::prototypes()
-        {
-            static int  rtx_ethernet_close(struct net_device *);
-        }
-
-        chunk LKM::code()
-        {
-            static int  rtx_ethernet_close(struct net_device *dev)
-            {
-                ${Ethernet::AbstractDevice.ref} rtx_net_dev;
-                { /* XXX: I end up with a placeholder if I don't open a scope */
-                    ${local.rtx_net_dev.init(local.dev)};
-                }
-
-                ${Ethernet::Device.ref} rtx_ether_ctx = ${local.rtx_net_dev.rtx_ether_ctx};
-
-                /* TODO: change this pointcut into a pointcut/adapter/callback: */
-                {
-                    ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx)};
-                }
-
-                free_irq(${local.rtx_ether_ctx.irq}, dev);
-                {
-                    ${Log::info("interrupt handler free'ed")};
-                }
-
-                return 0;
-            }
-        }
-    }
-
-    template sequence   Ethernet::interrupt_handler(Ethernet::Device dev)
+    template sequence   Ethernet::interrupt_handler()
     {
         /*
          * We can't use the irqreturn_t type here because CNornm doesn't know
@@ -258,29 +276,34 @@
          */
         chunk LKM::prototypes()
         {
-            static enum irqreturn   rtx_ethernet_interrupt_handler(int, void *);
+            static enum irqreturn rtx_ethernet_interrupt_handler(int, void *);
         }
 
         chunk LKM::code()
         {
-            static enum irqreturn   rtx_ethernet_interrupt_handler(int irq, void *dev_id)
+            static enum irqreturn rtx_ethernet_interrupt_handler(int irq, void *dev_id)
             {
                 ${Ethernet::AbstractDevice.ref} rtx_net_dev = dev_id;
                 ${Ethernet::Device.ref} rtx_ether_ctx;
                 rtx_ether_ctx = ${local.rtx_net_dev.rtx_ether_ctx};
 
-                ${pointcut ::IMPLEMENTATION(local.rtx_ether_ctx)};
+                ${pointcut Ethernet::adapter_handle_interrupt(local.rtx_ether_ctx)};
 
                 return IRQ_NONE;
             }
         }
+
+        /* XXX This chunk should be removed (see #26) */
+        chunk   ::CALL()
+        {
+        }
     }
 
     template sequence   Ethernet::init()
     {
         chunk LKM::data()
         {
-            static const struct net_device_ops  rtx_ether_ops =
+            static const struct net_device_ops rtx_ether_ops =
             {
                 .ndo_open = rtx_ethernet_open,
                 .ndo_stop = rtx_ethernet_close,
@@ -288,74 +311,65 @@
             };
         }
 
-        /*
-         * NOTE: for now, the error handling is leaking from PCI::probe(), but
-         * it's better than doing it at all.
-         *
-         * XXX: the chunk argument isn't correctly expanded by the
-         * compiler I have to use the same name as the actual C
-         * variable:
-         */
+        // NOTE: for now, the error handling is leaking from PCI::probe(), but
+        // it's better than not doing it at all.
+        //
+        // XXX: the chunk argument isn't correctly expanded by the compiler I
+        // have to use the same name as the actual C variable:
         chunk PCI::pci_probe_hook(PCI::Device rtx_pci_dev)
         {
-            ${Ethernet::AbstractDevice.ref} rtx_net_dev;
-            ${Ethernet::Device.ref} rtx_ether_ctx;
+            {
+                ${Ethernet::AbstractDevice.ref} rtx_net_dev;
+                ${Ethernet::Device.ref} rtx_ether_ctx;
 
-            rtx_net_dev = (${Ethernet::AbstractDevice.ref})alloc_etherdev(sizeof(*rtx_ether_ctx));
-            if (!rtx_net_dev)
-            {
-                ${Log::info("cannot allocate the ethernet device context")};
-                error = -ENOMEM;
-                goto fail;
+                rtx_net_dev = (${Ethernet::AbstractDevice.ref})alloc_etherdev(sizeof(*rtx_ether_ctx));
+                if (!rtx_net_dev)
+                {
+                    ${Log::info("cannot allocate the ethernet device context")};
+                    error = -ENOMEM;
+                    goto fail;
+                }
+                // XXX Past this point we should have another label to do
+                // free_netdev(rtx_net_dev) in case of failure but we don't
+                // have a nice way of doing that.
+                SET_NETDEV_DEV(${local.rtx_net_dev.k_net_dev}, ${rtx_pci_dev.device});
+                strlcpy(${local.rtx_net_dev.k_net_dev}->name,
+                        ${config.ifname},
+                        sizeof(${local.rtx_net_dev.k_net_dev}->name));
+                ${local.rtx_net_dev.k_net_dev}->irq = ${rtx_pci_dev.irq};
+                ${local.rtx_net_dev.k_net_dev}->netdev_ops = &rtx_ether_ops;
+
+                error = register_netdev(${local.rtx_net_dev.k_net_dev});
+                if (error)
+                {
+                    ${Log::info("cannot register the driver in the net subsystem")};
+                    goto fail;
+                }
+
+                /* Initialize our context held by the net_device structure */
+                { /* XXX: I end up with a placeholder if I don't open a scope */
+                    ${local.rtx_ether_ctx.init(local.rtx_net_dev, rtx_pci_dev.pci_device)};
+                }
+
+                /* Register ourselves in the parent context: */
+                /* ${rtx_pci_dev.set_context(local.rtx_ether_ctx)}; */
+                ${rtx_pci_dev.rtx_drv_context} = rtx_ether_ctx;
+
+                /*
+                 * XXX: the asssignments/casts are here to circumvent
+                 * typing issues in the compiler (see previous XXX).
+                 */
+                unsigned char /* __iomem */ *io_addr = ${rtx_pci_dev.ioaddr};
+                ${pointcut Ethernet::adapter_init_context(local.rtx_ether_ctx, local.io_addr)};
+                ${pointcut Ethernet::adapter_reset(local.rtx_ether_ctx)};
+                ${pointcut Ethernet::adapter_load_mac_address(local.rtx_ether_ctx)};
+                memcpy(${local.rtx_ether_ctx.perm_addr},
+                       ${local.rtx_ether_ctx.dev_addr},
+                       ${local.rtx_net_dev.k_net_dev}->addr_len);
             }
-            SET_NETDEV_DEV(${local.rtx_net_dev.k_net_dev}, ${rtx_pci_dev.device});
-            strlcpy(${local.rtx_net_dev.k_net_dev}->name,
-                    ${config.ifname},
-                    sizeof(${local.rtx_net_dev.k_net_dev}->name));
-            ${local.rtx_net_dev.k_net_dev}->irq = ${rtx_pci_dev.irq};
-            ${local.rtx_net_dev.k_net_dev}->netdev_ops = &rtx_ether_ops;
-
-            error = register_netdev(${local.rtx_net_dev.k_net_dev});
-            if (error)
-            {
-                ${Log::info("cannot register the driver in the net subsystem")};
-                goto fail;
-            }
-
-            /* Initialize our context held by the net_device structure */
-            /*
-             * XXX: the cast is here because the compiler resolve the
-             * type of rtx_pci_dev.pci_device to the type of
-             * rtx_pci_dev instead of the type of rtx_pci_dev.pci_device.
-             */
-            ${PCI::AbstractDevice.ref} workaround = ${rtx_pci_dev.pci_device};
-            ${cast local.workaround as PCI::AbstractDevice};
-            { /* XXX: I end up with a placeholder if I don't open a scope */
-                ${local.rtx_ether_ctx.init(local.rtx_net_dev, local.workaround)};
-            }
-
-            /* Register ourselves in the parent context: */
-            /* ${rtx_pci_dev.set_context(local.rtx_ether_ctx)}; */
-            ${rtx_pci_dev}->context = rtx_ether_ctx;
-
-            /*
-             * XXX: the asssignments/casts are here to circumvent
-             * typing issues in the compiler (see previous XXX).
-             */
-            int bars = ${rtx_pci_dev.bars};
-            unsigned char /* __iomem */ *ioaddr = ${rtx_pci_dev.ioaddr};
-            ${cast local.bars as Builtin::number};
-            ${pointcut Ethernet::adapter_init_context(local.rtx_ether_ctx,
-                                                      local.bars,
-                                                      local.ioaddr)};
-            ${pointcut Ethernet::adapter_reset(local.rtx_ether_ctx)};
-            ${pointcut Ethernet::adapter_load_mac_address(local.rtx_ether_ctx)};
-            memcpy(${local.rtx_ether_ctx.perm_addr},
-                   ${local.rtx_ether_ctx.dev_addr},
-                   ${local.rtx_net_dev.k_net_dev}->addr_len);
         }
 
-        /* This chunk should be removed (see #26) */
+        /* XXX This chunk should be removed (see #26) */
         chunk   ::CALL()
         {
         }
@@ -369,15 +383,17 @@
          */
         chunk   PCI::pci_remove_hook(PCI::Device rtx_pci_dev)
         {
-            ${Ethernet::Device.ref} rtx_ether_ctx = ${rtx_pci_dev.rtx_drv_context};
-            BUG_ON(!rtx_ether_ctx);
+            {
+                ${Ethernet::Device.ref} rtx_ether_ctx = ${rtx_pci_dev.rtx_drv_context};
+                BUG_ON(!rtx_ether_ctx);
 
-            ${Ethernet::AbstractDevice.ref} rtx_net_dev = ${local.rtx_ether_ctx.net_device};
-            unregister_netdev(${local.rtx_net_dev.k_net_dev});
-            free_netdev(${local.rtx_net_dev.k_net_dev});
+                ${Ethernet::AbstractDevice.ref} rtx_net_dev = ${local.rtx_ether_ctx.net_device};
+                unregister_netdev(${local.rtx_net_dev.k_net_dev});
+                free_netdev(${local.rtx_net_dev.k_net_dev});
+            }
         }
 
-        /* This chunk should be removed (see #26) */
+        /* XXX This chunk should be removed (see #26) */
         chunk ::CALL()
         {
         }
